<?php

namespace alldevs\IfocopBundle\Controller\DepotBanque;

use Admingenerated\alldevsIfocopBundle\BaseDepotBanqueController\ListController as BaseListController;
use DateTime;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;

class ListController extends BaseListController {

    public function printAction() {
        
        if ($this->get('request')->query->get('page')) {
            $this->setPage($this->get('request')->query->get('page'));
        }

        if ($this->get('request')->query->get('sort')) {
            $this->setSort($this->get('request')->query->get('sort'), $this->get('request')->query->get('order_by', 'ASC'));
        }
        
        $r=array();
        $nbre_group=0;
        $nbre_stag=0;
        $groupid="";
        $stagid="";
        $nbre_cheque=0;
        foreach($this->getPager() as $regle){
            if ($regle->getIdStagiaires()->getIdGroupes()->getId() != $groupid){
                $groupid=$regle->getIdStagiaires()->getIdGroupes()->getId();
                $nbre_group++;
                $typeannee=0;
                if ($regle->getIdStagiaires()->getIdGroupes()->getTypeannee()==1){
                    $typeannee="Année Civile";
                }else{
                    $typeannee="Année Scolaire";         
                }
                $r[$groupid]["nom_groupe"]=$regle->getIdStagiaires()->getIdGroupes()->getLib()." - ".$typeannee." : ".$regle->getIdStagiaires()->getIdGroupes()->getDateannee();
            }
            $nbre_cheque++;
            $stagid=$regle->getIdStagiaires()->getId();
            if($regle->getTypecompte()!=3){
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["idstag"]=$stagid;
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["idreglement"]=$regle->getId();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["banque"]=$regle->getBanquetireur();            
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["numcheque"]=$regle->getNumcheque();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["tireur"]=$regle->getTireur();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["nom"]=$regle->getIdStagiaires()->getNom()." ".$regle->getIdStagiaires()->getPrenom();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["numremise"]=$regle->getNumremise();
                if ($regle->getTypecompte()==1){
                    $r[$groupid][$regle->getTypecompte()][$nbre_stag]["typecompte"]=$regle->getNumcomptecs();
                }
                if ($regle->getTypecompte()==2){
                    $r[$groupid][$regle->getTypecompte()][$nbre_stag]["typecompte"]=$regle->getNumcomptedi();
                }
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["montant"]=$regle->getMontant();
                $nbre_stag++;
            }else{
                for($i=0;$i<2;$i++){
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["idstag"]=$stagid;
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["idreglement"]=$regle->getId();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["banque"]=$regle->getBanquetireur();            
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["numcheque"]=$regle->getNumcheque();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["tireur"]=$regle->getTireur();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["nom"]=$regle->getIdStagiaires()->getNom()." ".$regle->getIdStagiaires()->getPrenom();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["numremise"]=$regle->getNumremise();
                    if($i==0){
                        $r[$groupid][1][$nbre_stag."_".$i]["typecompte"]=$regle->getNumcomptecs();
                        $r[$groupid][1][$nbre_stag."_".$i]["montant"]=$regle->getRmbcs();
                    }else{
                        $r[$groupid][2][$nbre_stag."_".$i]["typecompte"]=$regle->getNumcomptedi();
                        $r[$groupid][2][$nbre_stag."_".$i]["montant"]=$regle->getRmbdi();
                    }
                    $nbre_stag++;
                }
            }
        }
        /*var_dump($r);
        exit;*/
        $form = $this->getFilterForm();
        $cmd = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:Reglement');
        $names = $cmd->getAssociationNames();
        $assocs = array();
        foreach ($names as $name) {
            if (!$cmd->isCollectionValuedAssociation($name)) {
                $tab = explode('\\', $cmd->getAssociationTargetClass($name));
                $assname = $tab[count($tab) - 1];
                $meta = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:' . $assname);
                $identifier = $meta->getSingleIdentifierFieldName();
                $assocs[$name] = array("field" => $assname, "refid" => $identifier);
            }
        }
        $multiids = array();
        if ($this->get('request')->query->has('isMulti') && $this->get('request')->query->get('motherid') != '') {
            $reprel = $this->getDoctrine()->getRepository('alldevsIfocopBundle:' . $this->get('request')->query->get('motherentity'));
            $relobj = $reprel->find($this->get('request')->query->get('motherid'));

            $pos = strpos($this->get('request')->query->get('class'), ":");
            $getter = "getId" . substr($this->get('request')->query->get('class'), $pos + 1);
            foreach ($relobj->$getter() as $stg) {
                $multiids[] = $stg->getId();
            }
        }
        $content = $this->renderView('alldevsIfocopBundle:DepotBanqueList:print.html.twig', $this->getAdditionalRenderParameters() + array(
            'Reglements' => $this->getPager(),
            'R' => $r,
            'Nbre_cheque' => $nbre_cheque,
            'form' => $form->createView(),
            'sortColumn' => $this->getSortColumn(),
            'sortOrder' => $this->getSortOrder(),
            'scopes' => $this->getScopes(),
            'assocs' => $assocs,
            'isSelect' => $this->get('request')->query->has('isSelect'),
            'isMulti' => $this->get('request')->query->has('isMulti'),
            'multiids' => $multiids
        ));

        $html2pdf = $this->get('html2pdf')->get();
        $html2pdf->WriteHTML($content);
        $content_PDF = $html2pdf->Output('', true);

        $response = new Response();

        // Set headers
        $response->headers->set('Cache-Control', 'private');
        $response->headers->set('Content-Disposition', 'attachment; filename="bordereau.pdf"');
        $response->headers->set('Content-type', 'application/pdf;charset=UTF-8');
        $response->headers->set('Content-Transfer-Encoding', 'binary');
        $response->headers->set('Pragma', 'no-cache');
        $response->headers->set('Expires', '0');

        // Send headers before outputting anything
        $response->sendHeaders();
        $response->sendContent();

        $response->setContent($content_PDF);
        return $response;
    }
    
  public function indexAction()
    {
        

        if ($this->get('request')->query->get('page'))
        {
          $this->setPage($this->get('request')->query->get('page'));
        }

        if ($this->get('request')->query->get('sort'))
        {
          $this->setSort($this->get('request')->query->get('sort'), $this->get('request')->query->get('order_by','ASC'));
        }
        
        $r=array();
        $nbre_group=0;
        $nbre_stag=0;
        $groupid="";
        $stagid="";
        $nbre_cheque=0;
        $show_compta=0;
        foreach($this->getPager() as $regle){
        
            $todayindex = new DateTime();
            $todayindex->setTime(0, 0, 0);
            if ($regle->getIdStagiaires()->getIdGroupes()->getId() != $groupid){
                $groupid=$regle->getIdStagiaires()->getIdGroupes()->getId();
                $nbre_group++;
                $typeannee=0;
                if ($regle->getIdStagiaires()->getIdGroupes()->getTypeannee()==1){
                    $typeannee="Année Civile";
                }else{
                    $typeannee="Année Scolaire";         
                }
                $r[$groupid]["nom_groupe"]=$regle->getIdStagiaires()->getIdGroupes()->getLib()." - ".$typeannee." : ".$regle->getIdStagiaires()->getIdGroupes()->getDateannee();
            }
            /*
            var_dump($regle->getDateremise()->format('Y-m-d 00:00:00'));
            var_dump($todayindex->format("Y-m-d 00:00:00"));
            exit;*/
            if($show_compta==0){
                if($regle->getDateremise()->format('Y-m-d 00:00:00') < $todayindex->format("Y-m-d 00:00:00")){
                    $show_compta=1;
                }
            }
            $nbre_cheque++;
            $stagid=$regle->getIdStagiaires()->getId();
            if($regle->getTypecompte()!=3){
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["idstag"]=$stagid;
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["idreglement"]=$regle->getId();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["banque"]=$regle->getBanquetireur();            
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["numcheque"]=$regle->getNumcheque();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["tireur"]=$regle->getTireur();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["nom"]=$regle->getIdStagiaires()->getNom()." ".$regle->getIdStagiaires()->getPrenom();
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["numremise"]=$regle->getNumremise();
                if ($regle->getTypecompte()==1){
                    $r[$groupid][$regle->getTypecompte()][$nbre_stag]["typecompte"]=$regle->getNumcomptecs();
                }
                if ($regle->getTypecompte()==2){
                    $r[$groupid][$regle->getTypecompte()][$nbre_stag]["typecompte"]=$regle->getNumcomptedi();
                }
                $r[$groupid][$regle->getTypecompte()][$nbre_stag]["montant"]=$regle->getMontant();
                $nbre_stag++;
            }else{
                for($i=0;$i<2;$i++){
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["idstag"]=$stagid;
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["idreglement"]=$regle->getId();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["banque"]=$regle->getBanquetireur();            
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["numcheque"]=$regle->getNumcheque();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["tireur"]=$regle->getTireur();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["nom"]=$regle->getIdStagiaires()->getNom()." ".$regle->getIdStagiaires()->getPrenom();
                    $r[$groupid][$i+1][$nbre_stag."_".$i]["numremise"]=$regle->getNumremise();
                    if($i==0){
                        $r[$groupid][1][$nbre_stag."_".$i]["typecompte"]=$regle->getNumcomptecs();
                        $r[$groupid][1][$nbre_stag."_".$i]["montant"]=$regle->getRmbcs();
                    }else{
                        $r[$groupid][2][$nbre_stag."_".$i]["typecompte"]=$regle->getNumcomptedi();
                        $r[$groupid][2][$nbre_stag."_".$i]["montant"]=$regle->getRmbdi();
                    }
                    $nbre_stag++;
                }
            }
        }
        /*var_dump($r);
        exit;*/
        $form = $this->getFilterForm();
        $cmd=$this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:Reglement');
        $names=$cmd->getAssociationNames();
        $assocs=array();
        foreach ($names as $name)
        {
            if (!$cmd->isCollectionValuedAssociation($name))
            {   
                $tab=explode('\\',$cmd->getAssociationTargetClass($name));
                $assname=$tab[count($tab)-1];
                $meta = $this->getEntityManager()->getClassMetadata('alldevsIfocopBundle:'.$assname);
                $identifier = $meta->getSingleIdentifierFieldName();
                $assocs[$name]=array("field"=>$assname,"refid"=>$identifier);
            }
        }
        $multiids=array();
        if ($this->get('request')->query->has('isMulti') && $this->get('request')->query->get('motherid')!='')
        {
            $reprel = $this->getDoctrine()->getRepository('alldevsIfocopBundle:'.$this->get('request')->query->get('motherentity'));
            $relobj=$reprel->find($this->get('request')->query->get('motherid'));  

            $pos=strpos($this->get('request')->query->get('class'),":");
            $getter="getId".substr($this->get('request')->query->get('class'),$pos+1);
            foreach ($relobj->$getter() as $stg)
            {
                $multiids[]=$stg->getId();
            }
        }
        $print=0;
       if($this->get('request')->query->has('print')){
            $print=1;
        }
        return $this->render('alldevsIfocopBundle:DepotBanqueList:index.html.twig', $this->getAdditionalRenderParameters() + array(
            'Reglements' => $this->getPager(),
            'R' => $r,
            'Nbre_cheque' => $nbre_cheque,
            'form'                      => $form->createView(),
            'sortColumn'                => $this->getSortColumn(),
            'sortOrder'                 => $this->getSortOrder(),
            'scopes'                    => $this->getScopes(),
            'assocs'                  => $assocs,
            'isSelect'   =>  $this->get('request')->query->has('isSelect'),
            'isMulti'   =>  $this->get('request')->query->has('isMulti'),
            'multiids' => $multiids,
            'print' => $print,
            'show_compta' => $show_compta,
            'afficher' => $this->get('session')->get('thrufilters')
        ));
        $this->get('session')->set('thrufilters', '0');
    }
    
    
    public function buildQuery() {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        $session=$this->getRequest()->getSession();

        $q = parent::buildQuery();

        $q->innerJoin("q.idModalite", "enmodal")->andWhere("enmodal.lib='Chèque' or enmodal.lib='Représentation chèque'")->innerJoin("q.idStagiaires", "enstag")->orderBy("engr.lib", "asc")->orderBy("enstag.nom", "asc")->orderBy("enstag.idGroupes", "asc");
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $q->innerJoin("enstag.idGroupes", "gr")->innerJoin("gr.idCentres", "c")->andWhere("c.id=".$this->getRequest()->getSession()->get("centre")->getId()."");
        }    
            $today = new DateTime();
            $today->setTime(0, 0, 0);
            
        if ($securityContext->isGranted('ROLE_COMPTABILITE') || $securityContext->isGranted('ROLE_ADMIN')) {
            //$q->andWhere("q.dateremise ='" . $today->format("Y-m-d 00:00:00") . "'");    
        }else{
            $q->andWhere("q.dateremise >='" . $today->format("Y-m-d 00:00:00") . "'");    
        }
      
        if($this->get('session')->get('thrufilters')==0){
            $q->andWhere("1!=1");
        }
        return $q;
    }

    public function filtersAction()
    {

        if ($this->get('request')->get('reset')) {
            //$this->setFilters(array());
            $this->get('session')->set('thrufilters', '0');
            return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_DepotBanque_list"));
        }

        if ($this->getRequest()->getMethod() == "POST") {
            $form = $this->getFilterForm();
            $form->bind($this->get('request'));

            if ($form->isValid()) {
                $filters = $form->getClientData();
            }
        }

        if ($this->getRequest()->getMethod() == "GET") {
            $filters = $this->getRequest()->query->all();
        }

        if (isset($filters)) {
            $this->setFilters($filters);
        }

        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_DepotBanque_list"));
    }
    
    public function batchAction() {
        if (!$this->get('request')->get('action') || !$this->get('request')->get('ids')) {
            return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_DepotBanque_list"));
        }


        $method = 'doBatch' . ucfirst($this->get('request')->get('action'));
        $this->$method($this->get('request')->get('ids'));

        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_DepotBanque_list")."?print=1");
    }

    public function doBatchAffectnum(array $ids) {
        $em = $this->getDoctrine()->getEntityManager();
        $repo = $em->getRepository('alldevsIfocopBundle:Reglement');
        $numremise = $this->get("request")->get("numremise");
        /* $dateremise=$this->get("request")->get("dateremise"); */
        foreach ($ids as $id) {
            $reg = $repo->find($id);
            if ($reg) {
                $reg->setValidation(1);
                $reg->setNumremise($numremise);
                /* $reg->setDateremise(new DateTime(str_replace('/', '-', $dateremise))); */
                $em->persist($reg);
            }
        }
        $em->flush();
    }
    /**
     * Store in the session service the current filters
     *
     * @param array the filters
     */
    protected function setFilters($filters)
    {
        $this->get('session')->set('thrufilters', '1');
        $this->get('session')->set('alldevs\IfocopBundle\DepotBanqueList\Filters', $filters);
    }
}

