<?php

namespace alldevs\IfocopBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;

class GestioncentreController extends Controller
{
    public function indexAction(Request $request)
    {
        $session=$this->getRequest()->getSession();
        $securityContext=$this->container->get('security.context') ;
        $user=$securityContext->getToken()->getUser();  
        $requete_centre=$request->get("centre");
        
        foreach ($user->getIdCentres() as $c){
            if($c->getId()==$requete_centre){
                $centre=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Centres')->find($requete_centre); 
                $session->set("centre", $centre);  
                $this->get('session')->getFlashBag()->add(
                    'notice',
                    'Le changement de centre c\'est effectué correctement !'
                );
            }else{
                $this->get('session')->getFlashBag()->add(
                    'notice',
                    'Le centre sélectionné ne peut vous être attribué!'
                );
            }
        }
        
        $referer = $request->headers->get('referer');
        if($referer){
            return new RedirectResponse($referer);
        }else{
            return new RedirectResponse($this->generateUrl('AdmingeneratorDashboard_welcome'));
        }
    }

}
