<?php

namespace alldevs\IfocopBundle\Controller\Groupes;

use Admingenerated\alldevsIfocopBundle\BaseGroupesController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \alldevs\IfocopBundle\Entity\Groupes $Groupes your \alldevs\IfocopBundle\Entity\Groupes object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Groupes $Groupes)
    {
        if ($Groupes->getIdStagiaires())
        {
            foreach ($Groupes->getIdStagiaires() as $line)
            {
                $line->setIdGroupes($Groupes);
            }
        }
        
        foreach ($Groupes->getIdStagiaires() as $line)
            {
                if($line->getId()==NULL){
                    $line->setCs($line->getIdFormations()->getTarif());
                    $line->setDi($line->getIdFormations()->getDroitinscr());
                    $line->setTypeannee($Groupes->getTypeannee());
                    $line->setNbrheure($Groupes->getNbrheure());
                    $line->setDatedebut($Groupes->getDatedebut());
                    $line->setDatefin($Groupes->getDatefin());
                    $line->setDateannee($Groupes->getDateannee());
                    
                    $di=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Di')->findAll();  
                    foreach ($di as $droit)
                    {
                        $line->setComptedi($droit->getComptedi());        
                        $line->setComptecs($droit->getComptecs());                    
                    }
                }
            }
        
    }
}
