<?php

namespace alldevs\IfocopBundle\Controller\PrisesStandalone;

use Admingenerated\alldevsIfocopBundle\BasePrisesStandaloneController\DeleteController as BaseDeleteController;
use Exception;
use Symfony\Component\HttpFoundation\RedirectResponse;

class DeleteController extends BaseDeleteController
{
    public function indexAction($pk)
    {
    
        try {
            $Prises = $this->getObject($pk);

            

            $this->preRemove($Prises);
            $this->process($Prises);
            $this->postRemove($Prises);

            $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.batch.delete.success", array(), 'Admingenerator') );
        } catch (Exception $e) {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.batch.delete.error", array(), 'Admingenerator') );
            $exc=$this->onException($e, $Prises);
            if ($exc)
                return $exc;
        }
        if ($this->get('request')->get('return'))
            return new RedirectResponse($this->get('request')->get('return'));        
        else
            return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_list", array('modale'=>($this->get('request')->get('modale')!=null?true:false),'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1))));
    }

}
