<?php

namespace alldevs\IfocopBundle\Controller\PrisesStandalone;

use Admingenerated\alldevsIfocopBundle\BasePrisesStandaloneController\EditController as BaseEditController;
use Exception;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class EditController extends BaseEditController
{
    public function indexAction($pk)
    {
        $Prises = $this->getObject($pk);

        if (!$Prises) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Prises with id $pk can't be found");
        }

        $this->preForm($Prises);

        $form = $this->createForm($this->getEditType(), $Prises);

        return $this->render('alldevsIfocopBundle:PrisesStandaloneEdit:index.html.twig', $this->getAdditionalRenderParameters($Prises) + array(
            "Prises" => $Prises,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1)            
        ));
    }
    
    public function updateAction($pk)
    {
        $Prises = $this->getObject($pk);



        if (!$Prises) {
            throw new NotFoundHttpException("The alldevs\IfocopBundle\Entity\Prises with id $pk can't be found");
        }

        $this->preBindRequest($Prises);
        $form = $this->createForm($this->getEditType(), $Prises);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Prises);
                $this->saveObject($Prises);
                $this->postSave($form, $Prises);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );

                if($this->get('request')->request->has('save-and-add'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_new" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_new" ));
                }
                if($this->get('request')->request->has('save-and-list'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_list" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_list" ));
                }
                else
                {
                     if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_edit", array('pk' => $pk) )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                     else
                         return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_edit", array('pk' => $pk) ));
                }

            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Prises);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:PrisesStandaloneEdit:index.html.twig', $this->getAdditionalRenderParameters($Prises) + array(
            "Prises" => $Prises,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1)   ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1)              
        ));
    }


}
