<?php

namespace alldevs\IfocopBundle\Controller\PrisesStandalone;

use Admingenerated\alldevsIfocopBundle\BasePrisesStandaloneController\NewController as BaseNewController;
use DateTime;
use Exception;
use Symfony\Component\HttpFoundation\RedirectResponse;

class NewController extends BaseNewController
{
    public function preForm($Prises)
    {
        $Prises->setDateprise(new DateTime());
                
       if($this->get("request")->get("modale")!=NULL){
           $distagiaires=$this->get("request")->get("motherid");
           $stagiaires=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Stagiaires')->find($distagiaires);
           $Prises->setIdStagiaires($stagiaires);
           $Prises->setIdGroupes($stagiaires->getIdGroupes());
       }
    }
    public function preSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Prises $Prises)
    {
        $Prises->setTypeannee($Prises->getIdStagiaires()->getIdGroupes()->getTypeannee());
        $Prises->setDatedebut($Prises->getIdStagiaires()->getIdGroupes()->getDatedebut());
        $Prises->setDatefin($Prises->getIdStagiaires()->getIdGroupes()->getDatefin());
        $Prises->setReference($Prises->getIdOrganismes()->getReference());
    } 
    
    public function indexAction()
    {


        $Prises = $this->getNewObject();

        $this->preForm($Prises);

        $form = $this->createForm($this->getNewType(), $Prises);

        return $this->render('alldevsIfocopBundle:PrisesStandaloneNew:index.html.twig', $this->getAdditionalRenderParameters($Prises) + array(
            "Prises" => $Prises,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1)
        ));
    }
    
    public function createAction()
    {


        $Prises = $this->getNewObject();

        $this->preBindRequest($Prises);
        $form = $this->createForm($this->getNewType(), $Prises);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Prises);
                $this->saveObject($Prises);
                $this->postSave($form, $Prises);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );

                if($this->get('request')->request->has('save-and-add'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_new" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_new" ));
                }
                if($this->get('request')->request->has('save-and-list'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_list" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_list" ));
                }
                else
                {
                     if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_edit", array('pk' => $Prises->getId()) )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                     else
                         return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_PrisesStandalone_edit", array('pk' => $Prises->getId()) ));
                }
            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Prises);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:PrisesStandaloneNew:index.html.twig', $this->getAdditionalRenderParameters($Prises) + array(
            "Prises" => $Prises,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1)   ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1)               
        ));
    }
    

}
