<?php

namespace alldevs\IfocopBundle\Controller\Reglement;

use Admingenerated\alldevsIfocopBundle\BaseReglementController\NewController as BaseNewController;
use DateTime;
use Exception;
use Symfony\Component\HttpFoundation\RedirectResponse;

class NewController extends BaseNewController
{

    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \alldevs\IfocopBundle\Entity\Reglement $Reglement your \alldevs\IfocopBundle\Entity\Reglement object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \alldevs\IfocopBundle\Entity\Reglement $Reglement)
    {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        
        if ($Reglement->getIdPrises() != null)
        {
            $Reglement->setIdStagiaires($Reglement->getIdPrises()->getIdStagiaires());            
            $Reglement->setNumcomptecs($Reglement->getIdPrises()->getIdStagiaires()->getComptecs());
            $Reglement->setNumcomptedi($Reglement->getIdPrises()->getIdStagiaires()->getComptedi());
        }else{
            $Reglement->setNumcomptecs($Reglement->getIdStagiaires()->getComptecs());
            $Reglement->setNumcomptedi($Reglement->getIdStagiaires()->getComptedi());
        }
        
            
        if($securityContext->isGranted("ROLE_CENTRE")){            
            if($Reglement->getIdModalite()->getLib()=="Espèces" || $Reglement->getIdModalite()->getLib()=="Remboursement" ){
                $Reglement->setValidation(1);

            }else{
                $Reglement->setValidation(0);
            }
        }
        $session=$this->get('request')->getSession();
        
        $req=$this->get('request');
        //if ($req->getMethod()=="POST" && $req->request->has('save-and-add')){
            if($Reglement->getIdStagiaires()->getId()){
                if($session->get('usernow')!=$Reglement->getIdStagiaires()->getId()){
                    $session->set('usernow', $Reglement->getIdStagiaires()->getId());
                    $session->set('banquetireur', $Reglement->getBanquetireur());
                    $session->set('tireur', $Reglement->getTireur());
                    $session->set('renew', '1'); 
                }
            }else{
                if($session->get('usernow')!=$Reglement->getIdPrises()->getIdStagiaires()->getId()){
                    $session->set('usernow', $Reglement->getIdPrises()->getIdStagiaires()->getId());
                    $session->set('banquetireur', $Reglement->getBanquetireur());
                    $session->set('tireur', $Reglement->getTireur());
                    $session->set('renew', '1'); 
                }            
            }
        //}

    } 
    public function preForm($Reglement)
    {
       $session=$this->get('request')->getSession();
       
        if($this->get("request")->get("modale")!=NULL){
            $distagiaires=$this->get("request")->get("motherid");
            $stagiaires=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Stagiaires')->find($distagiaires);
            $Reglement->setIdStagiaires($stagiaires);
       }else{
           if($session->get('renew')){
               $distagiaires=$session->get('usernow');
               $stagiaires=$this->getDoctrine()->getEntityManager()->getRepository('alldevsIfocopBundle:Stagiaires')->find($distagiaires);
               if($session->get('renew') && $this->get("request")->get("mem")==1){
                    $Reglement->setIdStagiaires($stagiaires);
               }
           }
       }

       if($session->get('renew') && $this->get("request")->get("mem")==1){
            $Reglement->setBanquetireur($session->get('banquetireur'));
            $Reglement->setTireur($session->get('tireur'));
            $Reglement->setIdStagiaires($stagiaires);
       }
            
       $Reglement->setDatereception(new \DateTime());
    }
    
    public function indexAction()
    {
        $Reglement = $this->getNewObject();
        $this->preForm($Reglement);
        $form = $this->createForm($this->getNewType(), $Reglement);

        return $this->render('alldevsIfocopBundle:ReglementNew:index.html.twig', $this->getAdditionalRenderParameters($Reglement) + array(
            "Reglement" => $Reglement,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1) ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1),
            'mem' => ($this->get('request')->get('mem')!=null?$this->get('request')->get('mem'):-1)
        ));
    }
    
    public function createAction()
    {
        $Reglement = $this->getNewObject();

        $this->preBindRequest($Reglement);
        $form = $this->createForm($this->getNewType(), $Reglement);
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $Reglement);
                $this->saveObject($Reglement);
                $this->postSave($form, $Reglement);

                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );

                if($this->get('request')->request->has('save-and-add'))
                {
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_new" )."?mem=1&modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                          return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_new" )."?mem=1");
                }
                if($this->get('request')->request->has('save-and-list'))
                {
                    
                    if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_list" )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                    else
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_list" ));
                }
                else
                {
                     if ($this->get('request')->get('modale')!=null && $this->get('request')->get('modale'))
                        return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_edit", array('pk' => $Reglement->getId()) )."?modale=1&motherid=".$this->get('request')->get('motherid')."&motherentity=".$this->get('request')->get('motherentity'));
                     else
                         return new RedirectResponse($this->generateUrl("alldevs_IfocopBundle_Reglement_edit", array('pk' => $Reglement->getId()) ));
                }
            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $Reglement);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('alldevsIfocopBundle:ReglementNew:index.html.twig', $this->getAdditionalRenderParameters($Reglement) + array(
            "Reglement" => $Reglement,
            "form" => $form->createView(),
            'modale'=>($this->get('request')->get('modale')!=null?true:false),
            'motherid' => ($this->get('request')->get('motherid')!=null?$this->get('request')->get('motherid'):-1)   ,
            'motherentity' => ($this->get('request')->get('motherentity')!=null?$this->get('request')->get('motherentity'):-1) ,
            'mem' => ($this->get('request')->get('mem')!=null?$this->get('request')->get('mem'):-1)
        ));
    }
    
}
