<?php

namespace alldevs\IfocopBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Di
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\DiRepository")
 */
class Di
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var float
     *
     * @ORM\Column(name="montant", type="float")
     */
    private $montant;

    /**
     * @var string
     *
     * @ORM\Column(name="comptedi", type="string")
     */
    private $comptedi;    

    /**
     * @var string
     *
     * @ORM\Column(name="comptecs", type="string")
     */
    private $comptecs;        

    public function __toString()
    {
        return $this->getMontant();
    }



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set montant
     *
     * @param float $montant
     * @return Di
     */
    public function setMontant($montant)
    {
        $this->montant = $montant;
    
        return $this;
    }

    /**
     * Get montant
     *
     * @return float 
     */
    public function getMontant()
    {
        return $this->montant;
    }

    /**
     * Set comptedi
     *
     * @param string $comptedi
     * @return Di
     */
    public function setComptedi($comptedi)
    {
        $this->comptedi = $comptedi;
    
        return $this;
    }

    /**
     * Get comptedi
     *
     * @return string 
     */
    public function getComptedi()
    {
        return $this->comptedi;
    }

    /**
     * Set comptecs
     *
     * @param string $comptecs
     * @return Di
     */
    public function setComptecs($comptecs)
    {
        $this->comptecs = $comptecs;
    
        return $this;
    }

    /**
     * Get comptecs
     *
     * @return string 
     */
    public function getComptecs()
    {
        return $this->comptecs;
    }
}