<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;
use FOS\UserBundle\Model\User as BaseUser;

/**
 * Myuser
 *  
 * @ORM\Table(name="myuser")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\MyuserRepository")
 */
class Myuser extends BaseUser 
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     * @var \Centres
     * @ORM\ManyToMany(targetEntity="Centres", mappedBy="idMyuser", cascade="ALL")
     */
    private $idCentres;


    public function __construct()
    { 
        parent::__construct();
        // your own logic
    }
    

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    
    public function getExpiresAt()
    {
        return $this->expiresAt;
    }
    
    public function getCredentialsExpireAt()
    {
        return $this->credentialsExpireAt;
    }       



    /**
     * Set idCentres
     *
     * @param \alldevs\IfocopBundle\Entity\Centres $idCentres
     * @return Myuser
     */
    public function setIdCentres(\alldevs\IfocopBundle\Entity\Centres $idCentres = null)
    {
        $this->idCentres = $idCentres;
    
        return $this;
    }

    /**
     * Get idCentres
     *
     * @return \alldevs\IfocopBundle\Entity\Centres 
     */
    public function getIdCentres()
    {
        return $this->idCentres;
    }

    /**
     * Add idCentres
     *
     * @param \alldevs\IfocopBundle\Entity\Centres $idCentres
     * @return Myuser
     */
    public function addIdCentre(\alldevs\IfocopBundle\Entity\Centres $idCentres)
    {
        $this->idCentres[] = $idCentres;
    
        return $this;
    }

    /**
     * Remove idCentres
     *
     * @param \alldevs\IfocopBundle\Entity\Centres $idCentres
     */
    public function removeIdCentre(\alldevs\IfocopBundle\Entity\Centres $idCentres)
    {
        $this->idCentres->removeElement($idCentres);
    }
}
