<?php

namespace alldevs\IfocopBundle\Controller\Groupes;

use Admingenerated\alldevsIfocopBundle\BaseGroupesController\ListController as BaseListController;
use Symfony\Component\HttpFoundation\Request;

class ListController extends BaseListController
{
    public function buildQuery() {
        $securityContext = $this->container->get('security.context');
        $myuser=$securityContext->getToken()->getUser();
        $session=$this->getRequest()->getSession();
        $q = parent::buildQuery();
        if ($securityContext->isGranted('ROLE_CENTRE')) {
            $q->innerJoin("q.idCentres", "c")->andWhere("c.id=".$this->getRequest()->getSession()->get("centre")->getId()."");
        }
        return $q;
    }
}
