<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Modalite
 * 
 * @ORM\Table(name="modalite")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\ModaliteRepository")
 */
class Modalite
{
    /**
     *     
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * 
     * @ORM\Column(name="lib", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     */
    private $lib;
    /**
     * 
     * @ORM\Column(name="droit", type="integer", nullable=true)
     * 
     */
    private $droit;

    public function __toString()
    {
            return $this->getLib();
    }
    

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Modalite
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }

    /**
     * Set droit
     *
     * @param integer $droit
     * @return Modalite
     */
    public function setDroit($droit)
    {
        $this->droit = $droit;
    
        return $this;
    }

    /**
     * Get droit
     *
     * @return integer 
     */
    public function getDroit()
    {
        return $this->droit;
    }
}