<?php

namespace alldevs\IfocopBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * Voie
 *
 * @ORM\Table(name="voie")
 * @ORM\Entity(repositoryClass="alldevs\IfocopBundle\Entity\VoieRepository")
 */
class Voie
{
    /**
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     *
     * @ORM\Column(name="lib", type="string", length=20, nullable=false)
     * @Assert\NotBlank()
     * @Assert\MaxLength(20)       
     */
    private $lib;
    
    public function __toString()
    {
            return $this->getLib();
    }
   

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set lib
     *
     * @param string $lib
     * @return Voie
     */
    public function setLib($lib)
    {
        $this->lib = $lib;
    
        return $this;
    }

    /**
     * Get lib
     *
     * @return string 
     */
    public function getLib()
    {
        return $this->lib;
    }
}