<?php

namespace alldevs\IfocopBundle\Form\Type\Facture;
use Symfony\Component\Form\FormBuilderInterface;
use Admingenerated\alldevsIfocopBundle\Form\BaseFactureType\FiltersType as BaseFiltersType;

class FiltersType extends BaseFiltersType
{
     public function buildForm(FormBuilderInterface $builder, array $options)
     {
           parent::buildForm($builder,$options);
          $builder->add('idStagiaires', 'entity', array('query_builder' => function($er) {
                return $er->createQueryBuilder('u')->orderBy('u.nom', 'ASC');
            },  'em' => 'default',  'class' => 'alldevs\\IfocopBundle\\Entity\\Stagiaires',  'multiple' => false,  'required' => false,  'label' => 'Liée au Stagiaire',  'help' => NULL,  'translation_domain' => 'Admin',  'cascade_validation' => true,));
            
           $builder->add('idGroupes', 'entity', array('query_builder' => function($er) {
                return $er->createQueryBuilder('u')->orderBy('u.lib', 'ASC');
            },  'em' => 'default',  'class' => 'alldevs\\IfocopBundle\\Entity\\Groupes',  'multiple' => false,  'required' => false,  'label' => 'Liée au Groupe',  'help' => NULL,  'translation_domain' => 'Admin',  'cascade_validation' => true,));
            
           $builder->add('OrgaPrises', 'entity', array('query_builder' => function($er) {
                return $er->createQueryBuilder('u')->innerJoin("u.idPrises", "p")->andWhere("u.id=p.idOrganismes")->orderBy('u.lib', 'ASC');
            },  'em' => 'default',  'class' => 'alldevs\\IfocopBundle\\Entity\\Organismes',  'multiple' => false,  'required' => false, 'mapped'=> false,  'label' => 'Liée à la Prise en charge',  'help' => NULL,  'translation_domain' => 'Admin',  'cascade_validation' => true,));
     }
}
